// EasyExecDlg.h :  
//

#pragma once


#include <memory.h>
#include "afxwin.h"
#include <vector>

#include "Str.h"

const int MAX_SHORTCUT_NAME = 50;
const int MAX_FILE_NAME = 1024;

struct SExecuteConfig{
	char m_szShortcutName[MAX_SHORTCUT_NAME];
	char m_szParameter[MAX_FILE_NAME];
	char m_szProgramPath[MAX_FILE_NAME];
	char m_szProgramFolder[MAX_FILE_NAME];
	
	SExecuteConfig(char * szShortcutname, char * szParameter, char * szProgramPath, char* szProgramFolder)
	{
		strcpy(m_szShortcutName, szShortcutname);
		strcpy(m_szParameter, szParameter);
		strcpy(m_szProgramPath, szProgramPath);
		strcpy(m_szProgramFolder, szProgramFolder);
	}

	bool operator ==(const SExecuteConfig &executeconfig) const 
	{
		if(stricmp(executeconfig.m_szShortcutName ,m_szShortcutName) != 0 ||
			stricmp(executeconfig.m_szParameter, m_szParameter) != 0 ||
			stricmp(executeconfig.m_szProgramPath, m_szProgramPath) != 0 ||
			stricmp(m_szProgramFolder, m_szProgramFolder) != 0)
		{
			return false;
		}
		return true;
	}

	bool operator != (const SExecuteConfig & refExecuteConfig)
	{
		return !(*this == refExecuteConfig);
	}
};

void Log(char *str, ...);

// CEasyExecDlg ȭ 
class CEasyExecDlg : public CDialog
{
// 
public:
	CEasyExecDlg(CWnd* pParent = NULL);	// ǥ 

// ȭ  
	enum { IDD = IDD_EZEXEC_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV 

// 
protected:
	HICON m_hIcon;

	// ޽  Լ ߽ϴ.
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

protected:
	CString m_strProgramPath;
	CString m_strParam;
	CString m_strProgramFolder;
	CListBox m_listboxParameter;
	CString m_strShortcutName;
	std::vector<SExecuteConfig> m_vecExecuteConfig;
	tstring m_strFileDialogPath;
	tstring m_strFinalUsingFileName;

	afx_msg void OnBnClickedButtonFileFind();
	afx_msg void OnBnClickedButtonExecute();
	afx_msg void OnBnClickedButtonSaveSetting();
	afx_msg void OnBnClickedButtonLoadSetting();
	afx_msg void OnLbnSelchangeListParameter();
	afx_msg void OnBnClickedButtonAdd();
	afx_msg void OnBnClickedButtonRemove();
	afx_msg void OnBnClickedButtonModify();
	afx_msg void OnEnKillfocusEditTargetProgram();
	afx_msg void OnEnKillfocusEditParameter();

	void InitInputDlg();
	void Clear();
	void CopyExecuteConfig(const SExecuteConfig& refExecuteConfig);
	void CopyControlVariableValue(SExecuteConfig& refExecuteConfig);

	void LoadSetting();
	void SaveSetting();
	void LoadConfig(const char* szFileName);
	void SaveConfig(const char* szFileName);
public:
	CStatic m_static_CFGFileName;
};
