﻿#include "stdafx.h"
#include "AsyncSelectInterface.h"

CAsyncSelectInterface::CAsyncSelectInterface(const SOCKET& refSocket) : m_refSocket(refSocket)
{
}

CAsyncSelectInterface::~CAsyncSelectInterface()
{
}

void CAsyncSelectInterface::Set(HWND hWnd, unsigned int wMsg, long lEvent)
{
	WSAAsyncSelect(m_refSocket, hWnd, wMsg, lEvent);
}

void CAsyncSelectInterface::SocketProc(WPARAM wParam, LPARAM lParam)
{
	if(wParam != m_refSocket)
		return;

	if(WSAGETSELECTERROR(lParam))
	{
		OnClose();
		return;
	}

	switch(WSAGETSELECTEVENT(lParam))
	{
	case FD_CONNECT:
		OnConnect();
		break;
	case FD_READ:
		if(!OnReceive())
		{
			OnClose();
		}
		break;
	case FD_WRITE:
		OnSend();
		break;
	case FD_CLOSE:
		OnClose();
		break;
	}
}