﻿#include "stdafx.h"
#include "PacketQueue.h"
#include "PacketWorker.h"
#include "Buffer.h"

#include "Session.h"
#include "SessionManager.h"

/**
@brief 생성자. 패킷을 
@param nIdx 소켓 식별값
@param nAccKey 소켓 누적 키 값
@param pcBuffer 데이터를 담아둔 버퍼
*/
CPacketQueue::CPacketQueue(int nIdx, int nAccKey, CBuffer* pcBuffer) : m_nIdx(nIdx), m_nAccKey(nAccKey), m_pcBuffer(pcBuffer)
{
	_Push();
}

/**
@brief 소멸자. 암것도 안함.
*/
CPacketQueue::~CPacketQueue()
{
}

/**
@brief 데이터를 패킷큐에 넣는다
@return 성공 여부
*/
bool CPacketQueue::_Push()
{
	return CPacketWorker::_Push(this);
}

/**
@brief 데이터를 푼다.
*/
void CPacketQueue::Proc()
{
	if(GetSessionManager() == NULL)
	{
		LOG_ERROR(_T("%s GetSessionManager() == NULL"), __TFUNCTION__);
		return;
	}

	CSession* pcSession = GetSessionManager()->Get(m_nIdx, m_nAccKey);
	if(pcSession == NULL)
	{
		LOG_DEBUG(_T("%s pcSession == NULL [%d, %d]"), __TFUNCTION__, m_nIdx, m_nAccKey);
		return;
	}

	pcSession->PacketProcess(m_pcBuffer.Get());
}