﻿#include "stdafx.h"
#include "SocketInterface.h"

CWinSockObject CSocketInterface::m_WinSockObject;

/**
@brief 생성자. 소켓 인터페이스 초기화 작업을 한다
*/
CSocketInterface::CSocketInterface() : m_Socket(INVALID_SOCKET)
{
	m_SockAddrIn.sin_family = AF_INET;
	memset(m_SockAddrIn.sin_zero, 0, sizeof(m_SockAddrIn.sin_zero));
}

/*
@brief 소멸자. 릴리즈 메소드를 호출
*/
CSocketInterface::~CSocketInterface()
{
	Release();
}

/**
@brief 릴리즈 작업. 소켓을 닫는다.
*/
void CSocketInterface::Release()
{
	CloseSocket();
}

/**
@brief 소켓을 닫는 메소드
*/
void CSocketInterface::CloseSocket()
{
	CloseSocket(m_Socket);
}

/**
@brief 소켓을 닫는 메소드
@param refSocket 소켓의 참조자
*/
void CSocketInterface::CloseSocket(SOCKET& refSocket)
{
	if(refSocket == INVALID_SOCKET)
	{
		LOG_INFO(_T("%s socket == INVALID_SOCKET."), __TFUNCTION__);
		return;
	}

	struct linger stLinger = {0, 0};
	setsockopt(refSocket, SOL_SOCKET, SO_LINGER, (char* )&stLinger, sizeof(stLinger));

	//송 수신 모두 중단 시킨다
	shutdown(refSocket, SD_BOTH);
	closesocket(refSocket);
	refSocket = INVALID_SOCKET;
	LOG_DEBUG(_T("%s Success."), __TFUNCTION__);
}
