﻿#include "stdafx.h"
#include "debug_stream.h"
#include "sym_engine.h"

/**
@brief 예외 추적 메소드
@param dos 스택 추적 정보를 출력할 스트림
@param pex 예외 정보 포인터
@return 결과 값
*/
int exception_filter(dostream &dos, EXCEPTION_POINTERS* pex)
{
	if( !pex )
		return EXCEPTION_EXECUTE_HANDLER;

	sym_engine::stack_trace(dos, pex->ContextRecord);
	return EXCEPTION_EXECUTE_HANDLER;
}

/**
@brief 예외 추적 메소드
@param pex 예외 정보 포인터
@return 결과 값
*/
int exception_filter(EXCEPTION_POINTERS * pex)
{
	static dostream dos(_T("EasyLib"));
	if( !pex )
		return EXCEPTION_EXECUTE_HANDLER;

	sym_engine::stack_trace(dos, pex->ContextRecord);
	return EXCEPTION_EXECUTE_HANDLER;
}