﻿#pragma once

#include "AutoPtr.h"
#include "ManualPtr.h"

#pragma comment(lib,"mswsock.lib") 

class CSessionManager;
class CListener;

/**
@brief Accept 기능을 전담 하는 Class.
*/
class CAcceptor
{
	///CListener에게만 오픈한다.
	friend class CListener;

public: ///생성자체가 friend에서만 이뤄지므로, 다른 메소드들은 public으로 해도 괜찮음.
	///실질적인 Accept 메소드
	bool Accept();

	///다수 Accept
	void Accept(int nCount);

	///소멸자
	virtual ~CAcceptor();

private:
	///생성자. friend class인 CListener에서만 생성 가능하도록, private으로 지정했다.
	CAcceptor(CListener* pcListener);

private:
	///CListener의 포인터를 가진다. 소유권은 가지지 않기에 EASY::CManualPtr로 선언되었다.
	EASY::CManualPtr<CListener> m_pcListener;
};