﻿#pragma once

#include "SocketCommon.h"

class CPeer;

/**
@brief 소켓 IO 처리 하는 클래스들이 상속 받아야 할 베이스 클래스.
*/
class CIoInterface 
{
protected:
	///피어의 포인터를 가진다.
	CPeer* m_pcPeer;

public:
	///생성자
	CIoInterface();

	///소멸자
	virtual ~CIoInterface();

	///초기화
	virtual void Initialize() = 0;

	///자원 해제
	virtual void Release() = 0;

	///데이터 전송
	virtual bool Send(const unsigned int nLen, const void* data, const unsigned int nAddLen = 0, const void* pAddData = 0) = 0;

	///데이터 수신
	virtual bool OnReceive(unsigned int nLen, void* data) = 0;

	///피어 설정
	void SetPeer(CPeer* peer);

	///접속 끊기 동작
	virtual void Disconnect() = 0;
};