﻿#pragma once

#include "SocketCommon.h"
#include <map>
#include "SmartSingleton.h"
#include "SessionManager.h"

class CIocpWorker;
class CSession;
class CPeerExManager;
class CIocpInterface;

///key:스레드 핸들, value:iocp워커
typedef std::multimap<HANDLE, CIocpWorker*> STL_MULTIMAP_THREAD;

/**
@brief IOCP 쓰레드 (워커)를 관리하는 매니저
@desc 소켓 컨텍스트 매니저를 매니저가 생성될때 같이 생성한다. (스마트 싱글턴)
*/
class CIocpThreadManager : public CSmartSingleton<CSessionManager>
{
private:
	///스레드를 관리할 멀티맵
	static STL_MULTIMAP_THREAD m_stl_multimap_Thread;

public:
	///생성자
	CIocpThreadManager();

	///소멸자
	virtual ~CIocpThreadManager();

	///스레드에 등록
	static void Register(HANDLE hIOCP, size_t nThreadCnt);
	
	///스레드에서 뺌
	static void Unregister(HANDLE hIOCP);

	///자원 해제
	static void Release();
};