﻿#pragma once

#include "SmartSingleton.h"
#include "AutoPtr.h"
#include "PacketWorker.h"

class CBuffer;

/**
@brief 패킷을 큐에 넣는 클래스.
*/
class CPacketQueue
{
private:
	///찾을 CSession의 식별 키 값 
	const int m_nIdx;

	///찾을 CSession의 누적 키 값 
	const int m_nAccKey;

	///데이터 담을 버퍼
	EASY::CAutoPtr<CBuffer> m_pcBuffer;

public:
	///생성자
	CPacketQueue(const int nIdx, const int nAccKey, CBuffer* pcBuffer);

	///소멸자
	~CPacketQueue();

	///패킷 처리 메소드
	void Proc();

private:

	///패킷을 워커에 집어 넣는 메소드
	bool _Push();
};