﻿#pragma once

#include "SafeRefCount.h"
#include "Peer.h"

/**
@brief CPeer의 확장 클래스. 일 대 다 관계를 위해 Idx와 AccKey가 추가된 클래스다. 
*/
class CPeerEx : public CPeer, public CSafeRefCount 
{
	///식별 키 값 
	const int m_nIdx;	

	///누적 키 값.
	const int m_nAccKey;

public:
	///생성자
	CPeerEx(const int nIdx, const int nAccKey);

	///소멸자
	virtual ~CPeerEx();

	/**
	@brief 식별 키 값을 반환
	@return 식별 키 값
	*/
	const int GetIdx(){return m_nIdx;}

	/**
	@brief 식별 누적 키 값을 반환
	@return 누적 키 값
	*/
	const int GetAccKey(){return m_nAccKey;}

	///주기적으로 불려지는 함수
	virtual void Act();

	///접속 완료시 불려지는 메소드
	virtual void OnConnect();

	///접속 종료시 불려지는 메소드
	virtual void OnClose();

	///데이터 수신시 불려지는 메소드
	virtual int OnReceive(int nLen, void* data);
};