﻿#pragma once

#include "PeerEx.h"
#include <map>
#include "Session.h"
#include "CriticalSection.h"


typedef std::map<int, CPeerEx*> STL_MAP_PeerEx;

class CPeerExManager
{
protected:
	//Key:CPeerEx.m_nIdx, value: CPeerEx*인 맵
	STL_MAP_PeerEx m_stl_map_Peer;	

	///크리티컬 섹션
	CCriticalSection m_CriticalSection;

private:
	///피어의 해제 작업을 한다.
	void _Release(CPeerEx* pcPeer);

	///모든 데이터를 없앤다
	void _Clear();

public:
	///피어를 등록한다.
	void Set(CPeerEx* pcPeer);

	///피어를 찾는 메소드
	CPeerEx* Get(int nIdx, int nAccKey);

	///임의의 피어를 반환하는 메소드
	CPeerEx* GetRandPeer();

	///현재 사용중인 CPeerEx들의 Act를 불러주는 메소드
	void Act();

	///피어의 해제 작업을 한다.
	void Release(int nIdx, int nAccKey);

	///같은 그룹 (같은 IocpInterface의 그룹 내)의 Peer들에게 브로드 캐스트 한다.
	void BroadCast(int nLen, void* data, int nAddLen = 0, void* adddata = 0);

	/**
	@brief 크리티컬 섹션 진입
	*/
	inline void Enter(){m_CriticalSection.Enter();}

	/**
	@brief 크리티컬 섹션 퇴장
	*/
	inline void Leave(){m_CriticalSection.Leave();}

public:
	///생성자
	CPeerExManager();

	///소멸자
	~CPeerExManager();
};