#pragma once

#include "Define.h"
#include "Singleton.h"
#include <list>
#include "Thread.h"
#include "FunctionPtr.h"
#include "CriticalSection.h"

#define TIMER_TICK 20

class CTimerCallBack
{
	DWORD					m_dwLastTick;
	DWORD					m_dwInterval;
protected:
	CTimerCallBack(DWORD dwInterval, DWORD dwTick);

public:
	~CTimerCallBack();

	void Run(DWORD dwTick);

	virtual void Act() = 0;

	inline bool CheckTick(DWORD dwTick){return dwTick - m_dwLastTick >= m_dwInterval;}
	inline DWORD GetInterval(){return m_dwInterval;}
};


/**
@brief Ÿ̸ ŬԴϴ. ֱ ؾ  ü ϸ ش ð ȣǰ ˴ϴ.
*/
class CTimer : public CThread
{
	typedef std::list<CTimerCallBack*>				STL_LIST_TIMERCALLBACK;
	typedef std::list<CTimerCallBack*>::iterator	STL_LIST_TIMERCALLBACK_ITERATOR;

public:
	/// 
	CTimer();
	/// Ҹ
	virtual ~CTimer();

	/// Ư ð   ۾ մϴ. 
	bool Register(CTimerCallBack* pTimerCallBack);
	/// ۾ մϴ.
	bool Unregister(CTimerCallBack* pTimerCallBack);

	///  CThread. Լ
	virtual void Act();

private:
	/**
	@brief   ˻
	@param pFunctor ˻ Functor
	@return  
	*/
	bool _IsExist(CTimerCallBack* pTimerCallBack)
	{
		STL_LIST_TIMERCALLBACK_ITERATOR itr = m_stl_list_Timers.begin();
		for(; itr!=m_stl_list_Timers.end(); ++itr)
		{
			CTimerCallBack* pCheckTimerCallBack = *itr;
			if( pTimerCallBack == pCheckTimerCallBack )
				return true;
		}
		return false;
	}
private:
	CEvent m_cEvent;
	STL_LIST_TIMERCALLBACK		m_stl_list_Timers;

	UINT32				m_nTick;
	CCriticalSection	m_cs;

	STATIC_SINGLETON_PTR(CTimer);

};
