﻿#include "stdafx.h"
#include "Main.h"
#include "LogManager.h"

#include "P2PRelayPeerEx.h"

#include "UDPSocket.h"
#include "PacketWorker.h"

DECLARE_ALLOCATE_FUNCTION(CP2PRelayPeerEx, RelayPeerAllocater);	

CMain::CMain(TCHAR* svrname, DWORD dwServiceStartType) : CEnvironmentManager(svrname, dwServiceStartType)
{
}

CMain::~CMain()
{
}

void CMain::Constructer()
{
	CListener::AllocThread(3);
	m_pcP2PRelayListener.reset(new CListener(&RelayPeerAllocater));

	if(!m_pcP2PRelayListener->Start(7890, 300))
		Stop();

	///이거 라이브러리단으로 옮기고, 리턴 왔을때의 포트와 주소 클라에 전달하도록 만들자!!
	m_pcUDPSocket.reset(new CUDPSocket);
	if(!m_pcUDPSocket->Bind(P2P_ECHO_PORT))
		Stop();
}

void CMain::Run()
{
	m_pcEvent->Wait(5000);

	m_pcP2PRelayListener->Act();
	m_pcP2PRelayListener->AliveCheck();
}

void CMain::Stop()
{
	CEnvironmentManager::Stop();
	CThread::Stop();
}

void CMain::Destructer()
{
	Stop();
	CListener::FreeThread();
	CPacketWorker::FreeThread();
}

void CMain::Act()
{
	Sleep(100);

	if(m_pcUDPSocket.get())
	{
		sockaddr_in sockaddrin;
		CBuffer* pcRecvBuffer = m_pcUDPSocket->Recv(&sockaddrin);
		LOG_INFO(_T("%s [%s, %d]"), __TFUNCTION__, inet_ntoa(sockaddrin.sin_addr),  ntohs(sockaddrin.sin_port));
		///CUDPSocket::Send(m_pcUDPSocket->GetSocket(), sockaddrin, sizeof(sockaddr_in), &sockaddrin);
	}
}