#pragma once

#include "Test.h"
#include <memory>

typedef struct STLPoolData
{
	int m_nData;


	static void *operator new(size_t size) {
		return STL_Pool.allocate(size);
	}
	static void operator delete(void *p, size_t size) {
		STL_Pool.deallocate((STLPoolData*)p, size);
	}
	static void *operator new[](size_t size) {
		return STL_Pool.allocate(size);
	}
	static void operator delete[](void *p, size_t size) {
		STL_Pool.deallocate((STLPoolData *)p, size);
	}
	static std::allocator<STLPoolData> STL_Pool;
} STLPoolData; // has destructor with side-effects

class CSTLPoolTest : public CTest
{
public:
	CSTLPoolTest();
	virtual ~CSTLPoolTest();

private:
	virtual void _Test();

private:
	STLPoolData* m_arrData[POOL_TEST_DATA_SIZE];
};