#include "stdafx.h"
#include "TestManager.h"
#include "Test.h"

CTestManager::CTestManager() : m_nTryCount(0), m_nSuccessCount(0), m_nFailCount(0)
{
}

CTestManager::~CTestManager()
{
	
}

void CTestManager::_Add(CTest* pcTest)
{
	m_stl_set_Test.insert(pcTest);
}

void CTestManager::_Remove(CTest* pcTest)
{
	m_stl_set_Test.erase(pcTest);
}

void CTestManager::_Result(bool bSuccess)
{
	m_nTryCount++;
	bSuccess ? m_nSuccessCount++ : m_nFailCount++;
}

void CTestManager::Run()
{
	for(STL_SET_TEST::iterator it =  m_stl_set_Test.begin(); it != m_stl_set_Test.end(); ++it)
	{
		CTest* pcTest = *it;
		pcTest->Run();
	}
	
	_Statistics();
}

void CTestManager::_Statistics()
{
	LOG_ALARM(_T("%s [T:%d, S:%d, F:%d]"), __TFUNCTION__, m_nTryCount, m_nSuccessCount, m_nFailCount);

	LOG_ALARM(_T("Test All Complete. Press Any Key."), __TFUNCTION__);
	getchar(); //ӽ ڵ. ŰԷ 
}